Package com.documentum.fc.client

# Interface IDfRouter

All Superinterfaces:
  `IDfPersistentObject`, `IDfSysObject`, `IDfTypedObject`

@Deprecated public interface IDfRouter extends IDfSysObject
Deprecated.
This class provides the functionality for the client to interact with dm_router objects in the repository. It extends IDfSysObject.

- ## Field Summary

  ### Fields inherited from interface com.documentum.fc.client.IDfPersistentObject

  `CURRENCY_CHECK_ALWAYS, CURRENCY_CHECK_FIRST_ACCESS, CURRENCY_CHECK_NEVER, CURRENCY_CHECK_ONCE_PER_SCOPE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `acquire(int taskNumber)`
  Deprecated.
  `int`
  `appendTask()`
  Deprecated.
  `void`
  `end()`
  Deprecated.
  `void`
  `force(int taskNumber, String message)`
  Deprecated.
  `void`
  `forward(int currentTask, IDfList additionalTask, String message)`
  Deprecated.
  `void`
  `halt()`
  Deprecated.
  `void`
  `insertTask(int position)`
  Deprecated.
  `void`
  `pause(int taskNumber)`
  Deprecated.
  `void`
  `reAssign(int taskNumber, String taskOwner, String message)`
  Deprecated.
  `void`
  `removeTask(int position)`
  Deprecated.
  `void`
  `resumeRouter(int taskNumber)`
  Deprecated.
  `void`
  `reverse(int currentTask, IDfList previousTask, String message)`
  Deprecated.
  `void`
  `signOffRouter(int taskNumber, String userOSName, String password)`
  Deprecated.
  `void`
  `start(String message)`
  Deprecated.
  `void`
  `validateRouter(boolean externalApps)`
  Deprecated.

  ### Methods inherited from interface com.documentum.fc.client.IDfPersistentObject

  `addChildRelative, addParentRelative, apiExec, apiGet, apiSet, destroy, fetch, fetchWithCaching, getAttrAssistance, getAttrAssistanceWithValues, getAttrAsstDependencies, getChildRelatives, getParentRelatives, getPartition, getType, getValidator, getVStamp, getWidgetType, isDeleted, isDirty, isInstanceOf, isNew, isReplica, lock, lockEx, registerEvent, removeChildRelative, removeParentRelative, revert, save, setPartition, signoff, unRegisterEvent, unRegisterEventEx, validateAllRules, validateAttrRules, validateAttrRulesWithValue, validateAttrRulesWithValues, validateObjRules, validateObjRulesWithValues`

  ### Methods inherited from interface com.documentum.fc.client.IDfSysObject

  `addDigitalSignature, addESignature, addNote, addReference, addRendition, addRenditionEx, addRenditionEx2, addRenditionEx3, appendContent, appendContentEx, appendFile, appendFileEx, appendPart, areAttributesModifiable, assemble, asVirtualDocument, attachPolicy, bindFile, branch, cancelCheckout, cancelCheckoutEx, cancelScheduledDemote, cancelScheduledPromote, cancelScheduledResume, cancelScheduledSuspend, canDemote, canPromote, canResume, canSuspend, checkin, checkinEx, checkout, checkoutEx, demote, destroyAllVersions, detachPolicy, disassemble, freeze, getAccessDate, getAccessorApplicationPermit, getAccessorCount, getAccessorName, getAccessorPermit, getAccessorPermitType, getAccessorXPermit, getAccessorXPermitNames, getACL, getACLDomain, getACLName, getAclRefValid, getAcsRequests, getAliasSet, getAliasSetId, getAntecedentId, getApplicationType, getAssembledFromId, getAuthors, getAuthorsCount, getBranchCount, getCabinetId, getChronicleId, getCollectionForContent, getCollectionForContentEx2, getCollectionForContentEx3, getCollectionForContentEx4, getComponentId, getComponentIdCount, getCompoundArchitecture, getContainId, getContainIdCount, getContent, getContentAvailability, getContentEx, getContentEx2, getContentEx3, getContentsId, getContentSize, getContentSize, getContentState, getContentStateCount, getContentType, getCreationDate, getCreatorName, getCurrentState, getCurrentStateName, getDirectDescendant, getDoubleContentAttr, getExceptionStateName, getFile, getFileEx, getFileEx2, getFolderId, getFolderIdCount, getFormat, getFrozenAssemblyCount, getFullText, getGroupName, getGroupPermit, getHasEvents, getHasFolder, getHasFrozenAssembly, getImplicitVersionLabel, getKeywords, getKeywordsCount, getLatestFlag, getLinkCount, getLinkHighCount, getLocations, getLockDate, getLockMachine, getLockOwner, getLogEntry, getMasterDocbase, getModifier, getModifyDate, getNextStateName, getObjectName, getOtherFileSize, getOwnerName, getOwnerPermit, getPageCount, getPath, getPathEx, getPathEx2, getPermissions, getPermit, getPermitEx, getPolicyId, getPolicyName, getPreviousStateName, getReferenceCount, getRemoteId, getRenditions, getResolutionLabel, getResumeState, getResumeStateName, getRetainerCount, getRetainerId, getRetainUntilDate, getRetentionDate, getRouters, getSpecialApp, getStatus, getStorageType, getStringContentAttr, getSubject, getTimeContentAttr, getTitle, getTypeName, getVdmPath, getVdmPathDQL, getVersionLabel, getVersionLabelCount, getVersionLabels, getVersionPolicy, getVersions, getWorkflows, getWorldPermit, getXPermit, getXPermitList, getXPermitNames, grant, grantPermit, hasPermission, insertContent, insertContentEx, insertFile, insertFileEx, insertPart, isArchived, isCheckedOut, isCheckedOutBy, isContentTransferCapabilityEnabled, isFrozen, isHidden, isImmutable, isLinkResolved, isPublic, isReference, isSuspended, isVirtualDocument, link, mark, mount, print, promote, prune, queue, refreshReference, removeContent, removeNote, removePart, removeRendition, removeRenditionEx, removeRenditionEx2, resolveAlias, resume, revertACL, revoke, revokePermit, saveAsNew, saveLock, scheduleDemote, schedulePromote, scheduleResume, scheduleSuspend, setACL, setACLDomain, setACLName, setApplicationType, setArchived, setAuthors, setCompoundArchitecture, setContent, setContentEx, setContentEx2, setContentType, setDoubleContentAttribute, setFile, setFileEx, setFullText, setGroupName, setGroupPermit, setHidden, setIsVirtualDocument, setKeywords, setLinkResolved, setLogEntry, setObjectName, setOwnerName, setOwnerPermit, setPath, setResolutionLabel, setSpecialApp, setStatus, setStorageType, setStringContentAttribute, setSubject, setTimeContentAttribute, setTitle, setWorldPermit, suspend, unfreeze, unlink, unmark, updatePart, updatePartEx, useACL, verifyESignature`

  ### Methods inherited from interface com.documentum.fc.client.IDfTypedObject

  `appendBoolean, appendDouble, appendId, appendInt, appendString, appendTime, appendValue, dump, enumAttrs, findAttrIndex, findBoolean, findDouble, findId, findInt, findString, findTime, findValue, getAllRepeatingStrings, getAttr, getAttrCount, getAttrDataType, getBoolean, getDouble, getId, getInt, getLong, getObjectId, getObjectSession, getOriginalSession, getRepeatingBoolean, getRepeatingDouble, getRepeatingId, getRepeatingInt, getRepeatingLong, getRepeatingString, getRepeatingTime, getRepeatingValue, getSession, getSessionManager, getString, getTime, getValue, getValueAt, getValueCount, hasAttr, insertBoolean, insertDouble, insertId, insertInt, insertString, insertTime, insertValue, isAttrRepeating, isNull, remove, removeAll, setBoolean, setDouble, setId, setInt, setNull, setRepeatingBoolean, setRepeatingDouble, setRepeatingId, setRepeatingInt, setRepeatingString, setRepeatingTime, setRepeatingValue, setSessionManager, setString, setTime, setValue, truncate`

- ## Method Details

  - ### acquire

    @Deprecated void acquire(int taskNumber) throws DfException
    Deprecated.
    Acquires a task for the current user from the task's owner.

    After a router task appears in a user's inbox, the user must acquire the task before he or she can begin working on the task. To acquire a task, the user must be the task's owner, or, if the task owner is a group, be a member of the group. Additionally, the router that generated the task must be in the active state and the task must be in the ready state.

    Parameters:
      `taskNumber` - Identifies the task to be acquired. Use the task's number.
    Throws:
      `DfException` - if the server returns an error

  - ### appendTask

    @Deprecated int appendTask() throws DfException
    Deprecated.
    Appends a new task to the router.

    Router tasks are recorded in a set of repeating attributes in dm_router objects. The values across one index position in the attributes represent one task in the router.

    This method appends a new task at the end of the values in those attributes.

    Returns:
      The index position of the new task
    Throws:
      `DfException` - if the server returns an error
    See Also:
      - `insertTask(int)`

  - ### end

    @Deprecated void end() throws DfException
    Deprecated.
    Removes a halted router from all inboxes, including the supervisor's inbox.

    To issue this method, the user must be the router's supervisor or a user with Sysadmin or Superuser privileges. The router must be in the halted state.

    Issuing this method sets the router's r_completion_date attribute to the current date and removes the router from all inboxes.

    Throws:
      `DfException` - if the server returns an error
    See Also:
      - `halt()`

  - ### force

    @Deprecated void force(int taskNumber, String message) throws DfException
    Deprecated.
    Moves a dormant router task to the ready state.

    To issue this method, the user must be the router's supervisor or a user with Sysadmin or Superuser privileges. The router must be in the active state, and the router task must be in the dormant state.

    Moving a task to the ready state puts the task in its owner's inbox.

    Parameters:
      `taskNumber` - Identifies the task to be moved to the ready state. Use the task's number.
      `message` - Defines a message to send to the task owner
    Throws:
      `DfException` - if the server returns an error

  - ### forward

    @Deprecated void forward(int currentTask, IDfList additionalTask, String message) throws DfException
    Deprecated.
    Moves the current task to the finished state and forwards the router to the owner of the next task.

    To issue this method, the user must be the task's user, the router's supervisor, or a user with Sysadmin or Superuser privileges. The task must be in the ready, acquired, or paused state.

    Parameters:
      `currentTask` - Identifies the task you are forwarding. Use the task's number.
      `additionalTask` - An IDfList object that identifies the next task or tasks in the router. The tasks must be identified by their task numbers.
      `message` - Defines a message for the owners of the next tasks.
    Throws:
      `DfException` - if the server returns an error

  - ### halt

    @Deprecated void halt() throws DfException
    Deprecated.
    Moves the router to the halted state and places it in the supervisor's inbox.

    To issue this method, the user must be the router's supervisor or a user with Sysadmin or Superuser privileges.

    Task owners cannot acquire or work on the router's tasks while the router is in the halted state.

    Throws:
      `DfException` - if the server returns an error
    See Also:
      - `end()`

  - ### insertTask

    @Deprecated void insertTask(int position) throws DfException
    Deprecated.
    Inserts a new task into the router.

    Router tasks are recorded in a set of repeating attributes in dm_router objects. The values across one index position in the attributes represent one task in the router.

    This method inserts a new task at the specified index position in those attributes. The task at that index position and those above it are renumbered.

    Parameters:
      `position` - Set this to the integer value representing the index positon into which you are inserting the task.
    Throws:
      `DfException` - if the server returns an error
    See Also:
      - `appendTask()`

  - ### pause

    @Deprecated void pause(int taskNumber) throws DfException
    Deprecated.
    Pauses a router task.

    Pausing a router task suspends the task. The task's owner cannot acquire or work on the task while it is in the paused state.

    To issue this method, the user must be the task's owner, the router's supervisor, or a user with Sysadmin or Superuser privileges.

    Parameters:
      `taskNumber` - Identifies the task you want to pause. Use the task's number.
    Throws:
      `DfException` - if the server returns an error

  - ### reAssign

    @Deprecated void reAssign(int taskNumber, String taskOwner, String message) throws DfException
    Deprecated.
    Reassigns a task to another user.

    To issue this method, the user must be the task's user, the router's supervisor, or a user with Superuser privileges. The task must be in the acquired state, and the router must be in the active state.

    If the user is the task's user, then the task can only be reassigned to the task's owner. If the task's user and owner are the same person, only the router's supervisor or a superuser can reassign the task to another user.

    Parameters:
      `taskNumber` - Set this to the number of the task you are reassigning
      `taskOwner` - Set this to the name of the new owner of the task
      `message` - Defines a message to be sent to the new task owner. This parameter is optional. You can specify an empty message.
    Throws:
      `DfException` - if the server returns an error

  - ### removeTask

    @Deprecated void removeTask(int position) throws DfException
    Deprecated.
    Deletes a task from a router.

    Deleting a task removes the row representing that task in each of the repeating attributes that define router tasks. All the rows that follow the deleted row are renumbered.

    Parameters:
      `position` - Set this to the task's index position in the repeating attributes
    Throws:
      `DfException` - if the server returns an error

  - ### resumeRouter

    @Deprecated void resumeRouter(int taskNumber) throws DfException
    Deprecated.
    Moves a paused task back to the acquired state.

    To issue this method, the user must be the task's user, the router's supervisor, or a user with Sysadmin or Superuser privileges. The router that contains the task must be in the active state.

    Parameters:
      `taskNumber` - Set this to the number of the task you want to resume
    Throws:
      `DfException` - if the server returns an error

  - ### reverse

    @Deprecated void reverse(int currentTask, IDfList previousTask, String message) throws DfException
    Deprecated.
    Removes a router from a user's inbox and returns it to the inbox of a previous task's user.

    A router in a user's inbox is represented by the router task. Reversing a router removes the associated task from the inbox and puts the router (and associated task) in the inbox of a previous task's owner. To reverse a router, the router must be in the ready, active, or paused state. Additionally, the user issuing the method must be:

    - the owner or user of the task representing the router being reversed,
    - the owner or user of the task to which you are reversing the router, or
    - a user with Sysadmin or Superuser privileges.

    Parameters:
      `currentTask` - Set this to the task number of the task which you are reversing
      `previousTask` - An IDfList object that identifies the task or tasks to which you are returning the router. Identify the tasks by number.
      `message` - Defines a message to be sent to the user or users receiving the reversed router
    Throws:
      `DfException` - if the server returns an error

  - ### signOffRouter

    @Deprecated void signOffRouter(int taskNumber, String userOSName, String password) throws DfException
    Deprecated.
    Records sign off information for a router task.

    A router's designer can require a task's user to sign off the task. If a sign-off is required, the task is not considered finished until the sign-off occurs.

    Parameters:
      `taskNumber` - Set this to the task number of the task you want signed off
      `userOSName` - Use this parameter to record the user's operating system login name. It is optional. If you pass this as an empty parameter, the session owner's name is used.
      `password` - The OS password of the user identified in `userOSName`.
    Throws:
      `DfException` - if the server returns an error

  - ### start

    @Deprecated void start(String message) throws DfException
    Deprecated.
    Starts the router.

    To start a router, you must be the router's supervisor, a user with at least Write permission on the router, or a user with Sysadmin or Superuser privileges.

    Starting a router moves all the dormant begin tasks to the active state, sets the router's state to active, and sets the r_state_date of the router to the current date.

    Parameters:
      `message` - Defines a message to be sent to the users of all the begin tasks in the router
    Throws:
      `DfException` - if the server returns an error

  - ### validateRouter

    @Deprecated void validateRouter(boolean externalApps) throws DfException
    Deprecated.
    Validates the router.

    After you define a router, it must be validated before you start it. Validating a router ensures that the task definitions and any external applications referenced by the router are valid.

    Parameters:
      `externalApps` - Set this to `true` if you want to validate user-defined applications that have been written to customize the workflow. Set this to `false` if you don't want to validate such applications or if none exist.
    Throws:
      `DfException` - if the server returns an error